/[MITgcm]/MITgcm/verification/testreport
ViewVC logotype

Contents of /MITgcm/verification/testreport

Parent Directory Parent Directory | Revision Log Revision Log | View Revision Graph Revision Graph


Revision 1.136 - (show annotations) (download)
Mon Mar 8 16:36:20 2010 UTC (14 years ago) by jmc
Branch: MAIN
CVS Tags: checkpoint62d
Changes since 1.135: +35 -22 lines
-add option '-runonly' (short: '-ro') to just do the run part (without make)
-more standard way to specify some options

1 #! /usr/bin/env bash
2 #
3 # $Header: /u/gcmpack/MITgcm/verification/testreport,v 1.135 2010/03/04 21:26:27 jmc Exp $
4 # $Name: $
5 #
6
7 usage()
8 {
9 echo
10 echo "Usage: $0 [OPTIONS]"
11 echo
12 echo "where possible OPTIONS are:"
13 echo " (-help|-h) print usage"
14 echo " (-mth) run multi-threaded (using eedata.mth)"
15 echo " (-mpi) compile and run using MPI"
16 echo " (-ieee/-noieee) if possible, use IEEE compiler flags"
17 echo " (DEF=\"-ieee\")"
18 echo " (-gsl) compile with \"-gsl\" flag"
19 echo " (-use_r4|-ur4) if allowed, use real*4 type for '_RS' variable"
20 echo " (-optfile|-of) STRING list of optfiles to use"
21 echo " (-addr|-a) STRING list of email recipients"
22 echo " (DEF=\"\" no email is sent)"
23 echo " (-mpackdir|-mpd) DIR location of the mpack utility"
24 echo " (DEF=\"../tools/mpack-1.6\")"
25 echo " (-tdir|-t) STRING list of group and/or exp. dirs to test"
26 echo " (recognized groups: basic, tutorials)"
27 echo " (DEF=\"\" which test all)"
28 echo " (-skipdir|-skd) STRING list of exp. dirs to skip"
29 echo " (DEF=\"\" which test all)"
30 echo " (-bash|-b) STRING preferred location of a \"bash\" or"
31 echo " Bourne-compatible \"sh\" shell"
32 echo " (DEF=\"\" for \"bash\")"
33 echo " (-adm|-ad) perform an adjoint run"
34 echo " (-oad) perform an OpenAD adjoint run"
35 echo " (-command|-c) STRING command to run"
36 echo " (-make|-m) STRING command to use for \"make\""
37 echo " (DEF=\"make\")"
38 echo " (-odir) STRING used to build output directory name"
39 echo " (DEF=\"hostname\")"
40 echo " (-ptracers|-ptr) STRING specify which ptracers to test"
41 echo " (DEF=\"1 2 3 4 5\")"
42 echo " (-match) NUMBER Matching Criteria (number of digits)"
43 echo " (DEF=\"12\")"
44 echo " (-j) JOBS use \"make -j JOBS\" for parallel builds"
45 echo " (-clean) *ONLY* run \"make CLEAN\""
46 echo " (-norun|-nr) skip the \"runmodel\" stage (stop after make)"
47 echo " (-runonly|-ro) *ONLY* run stage (=\"-quick\" without make)"
48 echo " (-quick|-q) same as \"-nogenmake -noclean -nodepend\""
49 echo " (-nogenmake|-ng) skip the genmake stage"
50 echo " (-noclean|-nc) skip the \"make clean\" stage"
51 echo " (-nodepend|-nd) skip the \"make depend\" stage"
52 echo " (-deldir|-dd) on success, delete the output directory"
53 echo " (-ts) provide timing information per timestep"
54 echo " (-papis) provide MFlop/s per timestep using PAPI"
55 echo " (-pcls) provide MFlop/s per timestep using PCL"
56 echo
57 echo "and where STRING can be a whitespace-delimited list"
58 echo "such as:"
59 echo
60 echo " -t 'exp0 exp2 exp3' "
61 echo " -addr='abc@123.com testing@home.org'"
62 echo
63 echo "provided that the expression is properly quoted within the current"
64 echo "shell (note the use of single quotes to protect white space)."
65 echo
66 exit 1
67 }
68
69 # build the mpack utility
70 build_mpack()
71 {
72 printf "building the mpack utility... "
73 MPACK="$MPACKDIR/mpack"
74 if test ! -x $MPACK ; then
75 if test ! -d $MPACKDIR ; then
76 echo
77 echo "Error: can't find \"$MPACKDIR\""
78 echo " are you sure this program is being run in the correct "
79 echo " (that is, \"MITGCM_ROOT\verification\") directory?"
80 echo
81 HAVE_MPACK=f
82 fi
83 if test "x$CC" = x ; then
84 export CC=cc
85 fi
86 printf "building mpack (using CC=$CC)... "
87 ( cd $MPACKDIR && ./configure && $MAKE ) > tr_build_mpack.out 2>&1
88 RETVAL=$?
89 if test "x$RETVAL" != x0 ; then
90 echo
91 echo "Error building the mpack tools at: $MPACK_DIR"
92 echo
93 HAVE_MPACK=f
94 else
95 rm -f tr_build_mpack.out
96 HAVE_MPACK=t
97 echo "done"
98 fi
99 else
100 HAVE_MPACK=t
101 echo "already exist"
102 fi
103 }
104
105 testoutput_var()
106 {
107 # testoutput_var dir s1 label subdir reference_output
108 #
109 # compares 1 variable output selected from file $dir/$subdir/$OUTPUTFILE
110 # with same output from reference file $dir/results/$reference_output
111 # using search strings s1 and text label
112
113 if [ $debug -gt 0 ]; then
114 echo testoutput_var: grep "$2" $1/$4/$OUTPUTFILE 1>&2
115 fi
116 if [ -r $1/$4/$OUTPUTFILE ]; then
117 grep "$2" $1/$4/$OUTPUTFILE | sed 's/.*=//' | cat -n > tmp1.txt
118 lncntA=`wc -l tmp1.txt | awk '{print $1}' `
119 if [ $lncntA -lt 2 ]; then
120 if [ $verbose -gt 0 ]; then
121 echo Not enough lines of output when searching for "$2" 1>&2
122 fi
123 return 99
124 fi
125 else
126 echo testoutput_var: $OUTPUTFILE from model run was not readable 1>&2
127 return 99
128 fi
129 if [ $debug -gt 0 ]; then
130 echo testoutput_var: grep "$2" $1/results/$5 1>&2
131 fi
132 grep "$2" $1/results/$5 | sed 's/.*=//' | cat -n > tmp2.txt
133 lncntB=`wc -l tmp2.txt | awk '{print $1}' `
134 if [ $lncntB -lt 2 ]; then
135 if [ $verbose -gt 0 ]; then
136 echo Not enough lines of output when searching for "$2" 1>&2
137 fi
138 return 99
139 fi
140 if [ $lncntA -ne $lncntB ]; then
141 if [ $verbose -gt 0 ]; then
142 echo Not same Nb of lines when searching for "$2" ":" $lncntA $lncntB 1>&2
143 fi
144 return 99
145 fi
146 has_nan=`cat tmp1.txt | grep -i nan | wc -l`
147 if [ $has_nan -gt 0 ] ; then
148 echo testoutput_var: $OUTPUTFILE contains $has_nan NaN values 1>&2
149 return 99
150 fi
151 has_inf=`cat tmp1.txt | grep -i inf | wc -l`
152 if [ $has_inf -gt 0 ] ; then
153 echo testoutput_var: $OUTPUTFILE contains $has_inf Inf values 1>&2
154 return 99
155 fi
156 if [ $debug -gt 0 ]; then
157 echo testoutput_var: join tmp1.txt tmp2.txt 1>&2
158 fi
159 join tmp1.txt tmp2.txt | awk '{print $1 " " $2 " " $3}' > tmp3.txt
160 if [ $debug -gt 0 ]; then
161 echo testoutput_var: compare_lines 1>&2
162 fi
163 if [ $verbose -gt 1 ]; then
164 cat tmp3.txt 1>&2
165 fi
166 echo "-1" >> tmp3.txt
167 # On the SGI O3K (*not* the O2K), "cat -n" inserts a ":" after the line number
168 cat tmp3.txt | sed -e 's|:||g' > tmp4.txt
169 digits_of_similarity=`./tr_cmpnum < tmp4.txt`
170 if [ $digits_of_similarity -eq 99 ]; then
171 if [ $verbose -gt 0 ]; then
172 echo testoutput_var: No comparison was available for \"$3\" 1>&2
173 fi
174 digits_of_similarity=99
175 else
176 if [ $verbose -gt 0 ]; then
177 echo There were $digits_of_similarity decimal places of similarity for \"$3\" 1>&2
178 fi
179 fi
180 rm -f tmp1.txt tmp2.txt tmp3.txt tmp4.txt
181
182 return $digits_of_similarity
183 }
184
185 testoutput_run()
186 {
187 # testoutput_run directory subdir reference_output
188 #
189 # test output from 1 run in "directory"
190 # --> same processing for adjoint & forward test
191 # default list of output variables to be checked:
192 # 1rst : main variable used to decide if it pass or FAIL
193 # others : number of matching digits to be printed in summary.txt
194 listChk=$DEF_CHECK_LIST
195 # load experiment-specific list from file "tr_checklist" (if it exist)
196 if test -r $1/$2/tr_checklist ; then listChk=`cat $1/$2/tr_checklist` ; fi
197 sVar=`echo $listChk | awk '{print $1}'`
198 # remove 1rst var and expand the list: + => min max mean s.d
199 listVar=`echo $listChk | sed 's/ [a-zA-Z0-9]*+/&mn &mx &av &sd/g' \
200 | sed 's/+//g' | sed "s/^$sVar//"`
201 if [ $debug -gt 0 ]; then echo "testoutput_run: listVar(I)='$listVar'" 1>&2 ; fi
202 # check for ptracer output in reference_output file :
203 outpref=$1/results/$3
204 ptr_mon="trcstat_ptracerXX_min trcstat_ptracerXX_max"
205 ptr_mon="$ptr_mon trcstat_ptracerXX_mean trcstat_ptracerXX_sd"
206 for ii in $PTRACERS_NUM ; do
207 ptrfound=0
208 for jj in $ptr_mon ; do
209 name=`eval "echo $jj | sed -e 's|XX|0"$ii"|g'"`
210 tst=`grep $name $outpref | wc -l | awk '{print $1}'`
211 if test ! "x$tst" = x0 ; then ptrfound=1 ; fi
212 done
213 if test $ptrfound = '1' ; then
214 eval "HAVE_PTR0"$ii"=t"
215 else
216 eval "HAVE_PTR0"$ii"=f"
217 if test "x$ADM" = x -a "x$OADM" = x; then
218 # remove this ptr from the list of output variable to check
219 # echo "-- ptr test=" $tst "number of var=" `echo $listVar | awk '{print NF}'` 1>&2
220 listVar=`echo "$listVar" | sed "s/ pt$ii..//g"`
221 fi
222 fi
223 # eval 'echo "HAVE_PTR0'$ii' = $HAVE_PTR0'$ii'"' 1>&2
224 done
225 tst=`echo $sVar $listVar | awk '{ for(i=2;i<=NF;i++){if($i==$1)t+=1}; print t }'`
226 if test $tst != 1 ; then
227 if test $tst = 0 ; then echo "==> WARNING: selected var >$sVar< not found" 1>&2
228 else echo "==> WARNING: found selected var >$sVar< $tst times" 1>&2 ; fi
229 echo "==> WARNING: in checked list:" $listVar 1>&2
230 #- put it back once:
231 listVar=" $sVar "`echo "$listVar " | sed "s/ $sVar / /g"`
232 fi
233 if [ $debug -gt 0 ]; then echo "testoutput_run: listVar(M)='$listVar'" 1>&2 ; fi
234 echo "listVar='$listVar'" > $CDIR"/summary.txt"
235 allargs=""
236 for xx in $listVar
237 do
238 case $xx in
239 'PS') if [ $debug -gt 0 ]
240 then echo testoutput_run: testoutput_var $1 cg2d_init_res 1>&2 ; fi
241 testoutput_var $1 "cg2d_init_res" "Press. Solver (cg2d)" $2 $3; yy=$?
242 if [ $debug -gt 0 ] ; then echo testoutput_run: cg2dres=$yy 1>&2 ; fi ;;
243 'Cost') testoutput_var $1 "ADM precision_derivative_cost" "ADM Cost" $2 $3; yy=$? ;;
244 'Grad') testoutput_var $1 "ADM precision_derivative_grad" "ADM Grad" $2 $3; yy=$? ;;
245 'Tmn') testoutput_var $1 "dynstat_theta_min" "Theta minimum" $2 $3; yy=$? ;;
246 'Tmx') testoutput_var $1 "dynstat_theta_max" "Theta maximum" $2 $3; yy=$? ;;
247 'Tav') testoutput_var $1 "dynstat_theta_mean" "Theta mean" $2 $3; yy=$? ;;
248 'Tsd') testoutput_var $1 "dynstat_theta_sd" "Theta Std.Dev" $2 $3; yy=$? ;;
249 'Smn') testoutput_var $1 "dynstat_salt_min" "Salt minimum" $2 $3; yy=$? ;;
250 'Smx') testoutput_var $1 "dynstat_salt_max" "Salt maximum" $2 $3; yy=$? ;;
251 'Sav') testoutput_var $1 "dynstat_salt_mean" "Salt mean" $2 $3; yy=$? ;;
252 'Ssd') testoutput_var $1 "dynstat_salt_sd" "Salt Std.Dev" $2 $3; yy=$? ;;
253 'Umn') testoutput_var $1 "dynstat_uvel_min" "U minimum" $2 $3; yy=$? ;;
254 'Umx') testoutput_var $1 "dynstat_uvel_max" "U maximum" $2 $3; yy=$? ;;
255 'Uav') testoutput_var $1 "dynstat_uvel_mean" "U mean" $2 $3; yy=$? ;;
256 'Usd') testoutput_var $1 "dynstat_uvel_sd" "U Std.Dev" $2 $3; yy=$? ;;
257 'Vmn') testoutput_var $1 "dynstat_vvel_min" "V minimum" $2 $3; yy=$? ;;
258 'Vmx') testoutput_var $1 "dynstat_vvel_max" "V maximum" $2 $3; yy=$? ;;
259 'Vav') testoutput_var $1 "dynstat_vvel_mean" "V mean" $2 $3; yy=$? ;;
260 'Vsd') testoutput_var $1 "dynstat_vvel_sd" "V Std.Dev" $2 $3; yy=$? ;;
261 'pt1mn'|'pt2mn'|'pt3mn'|'pt4mn'|'pt5mn') ii=`echo $xx | sed 's/pt//' | sed 's/..$//'`
262 testoutput_var $1 "trcstat_ptracer0"$ii"_min" "p0"$ii"_min" $2 $3; yy=$? ;;
263 'pt1mx'|'pt2mx'|'pt3mx'|'pt4mx'|'pt5mx') ii=`echo $xx | sed 's/pt//' | sed 's/..$//'`
264 testoutput_var $1 "trcstat_ptracer0"$ii"_max" "p0"$ii"_max" $2 $3; yy=$? ;;
265 'pt1av'|'pt2av'|'pt3av'|'pt4av'|'pt5av') ii=`echo $xx | sed 's/pt//' | sed 's/..$//'`
266 testoutput_var $1 "trcstat_ptracer0"$ii"_mean" "p0"$ii"_mean" $2 $3; yy=$? ;;
267 'pt1sd'|'pt2sd'|'pt3sd'|'pt4sd'|'pt5sd') ii=`echo $xx | sed 's/pt//' | sed 's/..$//'`
268 testoutput_var $1 "trcstat_ptracer0"$ii"_sd" "p0"$ii"_StDv" $2 $3; yy=$? ;;
269 'Qntmn') testoutput_var $1 "forcing_qnet_min" "Qnet minimum" $2 $3; yy=$? ;;
270 'Qntmx') testoutput_var $1 "forcing_qnet_max" "Qnet maximum" $2 $3; yy=$? ;;
271 'Qntav') testoutput_var $1 "forcing_qnet_mean" "Qnet mean" $2 $3; yy=$? ;;
272 'Qntsd') testoutput_var $1 "forcing_qnet_sd" "Qnet Std.Dev" $2 $3; yy=$? ;;
273 'aSImn') testoutput_var $1 "seaice_area_min" "SIce Area min" $2 $3; yy=$? ;;
274 'aSImx') testoutput_var $1 "seaice_area_max" "SIce Area max" $2 $3; yy=$? ;;
275 'aSIav') testoutput_var $1 "seaice_area_mean" "SIce Area mean" $2 $3; yy=$? ;;
276 'aSIsd') testoutput_var $1 "seaice_area_sd" "SIce Area StDv" $2 $3; yy=$? ;;
277 'hSImn') testoutput_var $1 "seaice_heff_min" "SIce Heff min" $2 $3; yy=$? ;;
278 'hSImx') testoutput_var $1 "seaice_heff_max" "SIce Heff max" $2 $3; yy=$? ;;
279 'hSIav') testoutput_var $1 "seaice_heff_mean" "SIce Heff mean" $2 $3; yy=$? ;;
280 'hSIsd') testoutput_var $1 "seaice_heff_sd" "SIce Heff StDv" $2 $3; yy=$? ;;
281 'AthSiG') testoutput_var $1 "thSI_Ice_Area_G" "thSIc Area Global" $2 $3; yy=$? ;;
282 'AthSiS') testoutput_var $1 "thSI_Ice_Area_S" "thSIc Area South" $2 $3; yy=$? ;;
283 'AthSiN') testoutput_var $1 "thSI_Ice_Area_N" "thSIc Area North" $2 $3; yy=$? ;;
284 'HthSiG') testoutput_var $1 "thSI_IceH_ave_G" "thSIc H Global" $2 $3; yy=$? ;;
285 'HthSiS') testoutput_var $1 "thSI_IceH_ave_S" "thSIc H South" $2 $3; yy=$? ;;
286 'HthSiN') testoutput_var $1 "thSI_IceH_ave_N" "thSIc H North" $2 $3; yy=$? ;;
287 *) yy=99; echo "WARNING: asking for var=$xx : not recognized !" 1>&2 ;;
288 esac
289 if test $xx = $sVar
290 then allargs="$allargs > $yy <"
291 else allargs="$allargs $yy"
292 fi
293 done
294
295 nbVar=`echo $listVar | awk '{print NF}'`
296 if [ $nbVar -lt $LEN_CHECK_LIST ] ; then
297 #-- fill line (up to standard length) with dot:
298 adNul=`expr $LEN_CHECK_LIST - $nbVar | awk '{for(i=1;i<=$1;i++){print "."}}'`
299 echo $allargs $adNul
300 else
301 echo $allargs
302 fi
303 # <-- same processing for adjoint & forward test
304 }
305
306 genmakemodel()
307 {
308 # genmakemodel directory
309 if test "x$NOGENMAKE" = xt ; then
310 echo "genmake skipped!"
311 else
312 if test "x$BASH" = x ; then
313 GENMAKE2="../../../tools/genmake2"
314 else
315 GENMAKE2="$BASH ../../../tools/genmake2 -bash $BASH"
316 fi
317 (
318 cd $1;
319 command="$GENMAKE2 -ds -m $MAKE"
320 if test "x$ADM" = xt ; then
321 command="$command --mods=../code_ad"
322 elif test "x$OADM" = xt ; then
323 command="$command -adof ../../../tools/adjoint_options/adjoint_oad -mods '../code_oad ../../OpenAD/code_oad_all'"
324 else
325 command="$command -mods=../code"
326 fi
327 if test "x$OPTFILE" != xNONE ; then
328 command="$command -optfile=$OPTFILE"
329 fi
330 if test "x$IEEE" != x ; then
331 command="$command -ieee"
332 fi
333 if test "x$GSL" = xt ; then
334 command="$command -gsl"
335 fi
336 if test "x$MPI" = xt ; then
337 command="$command -mpi"
338 fi
339 if test "x$MULTI_THREAD" = xt ; then
340 #- run multi-threaded using OpenMP:
341 command="$command -omp"
342 fi
343 if test "x$USE_R4" = xt ; then
344 command="$command -use_r4"
345 fi
346 if test "x$TS" = xt ; then
347 command="$command -ts"
348 fi
349 if test "x$PAPIS" = xt ; then
350 command="$command -papis"
351 else
352 if test "x$PCLS" = xt ; then
353 command="$command -pcls"
354 fi
355 fi
356 printf 'genmake ... ' 1>&2
357 # $command > make.log 2>&1
358 eval $command > make.log 2>&1
359 RETVAL=$?
360 # Reduce the size of the testing emails!
361 head -100 Makefile > $CDIR/Makefile_head
362 if test "x$RETVAL" != x0 ; then
363 tail make.log
364 echo "genmakemodel: genmake failed" 1>&2
365 cp genmake_* make.log $CDIR
366 return 1
367 else
368 echo "successful" 1>&2
369 fi
370 )
371 fi
372 }
373
374 makeclean()
375 {
376 # makeclean directory
377 if test "x$NOCLEAN" = xt ; then
378 echo "make Clean skipped!"
379 else
380 (
381 cd $1;
382 #if test -e $OUTPUTFILE ; then rm -f $OUTPUTFILE ; fi
383 if test -r Makefile ; then
384 printf 'clean build-dir: make Clean ... ' 2>&1
385 $MAKE Clean >> make.log 2>&1
386 RETVAL=$?
387 if test "x$RETVAL" != x0 ; then
388 tail make.log
389 echo "makeclean: \"make Clean\" failed" 1>&2
390 cp make.log $CDIR"/make.log"
391 return 1
392 fi
393 echo successful 1>&2
394 else
395 echo ''
396 fi
397 exit 0
398 )
399 fi
400 }
401
402 run_clean()
403 {
404 # run_clean directory
405 if test "x$NOCLEAN" = xt ; then
406 echo "run_clean skipped!"
407 else
408 (
409 cd $1;
410 printf 'clean run-dir ... ' 2>&1
411 # part of what is done after "make clean" when doing "make CLEAN"
412 find . -name "*.meta" -exec rm {} \;
413 find . -name "*.data" -exec rm {} \;
414 find . -name "fort.*" -exec rm {} \;
415 find . -type l -exec rm {} \;
416 rm -f $EXECUTABLE *.txt STD* *diagnostics.log datetime
417 rm -rf mnc_test_*
418 rm -f *_MIT_CE_000.opt0000 costfunction*0000
419 echo successful 1>&2
420 exit 0
421 )
422 fi
423 }
424
425 makedependmodel()
426 {
427 # makedependmodel directory
428 if test "x$NODEPEND" = xt ; then
429 echo "make depend skipped!"
430 else
431 (
432 cd $1;
433 printf 'make depend ... ' 1>&2
434 $MAKE depend >> make.log 2>&1
435 RETVAL=$?
436 if test "x$RETVAL" != x0 ; then
437 tail make.log
438 echo "makedependmodel: make depend failed" 1>&2
439 cp make.log $CDIR"/make.log"
440 return 1
441 else
442 echo successful 1>&2
443 fi
444 )
445 fi
446 }
447
448 makemodel()
449 {
450 # makemodel directory
451 (
452 if test "x$NOMAKE" = xt ; then
453 cd $1;
454 if test -x $EXECUTABLE ; then
455 echo "make skipped!"
456 else
457 echo "no executable!"
458 return 2
459 fi
460 else
461 cd $1;
462 if test -r Makefile ; then
463 printf 'make ... ' 1>&2
464 if test "x$ADM" = xt ; then
465 $MAKE adall >> make.log 2>&1
466 elif test "x$OADM" = xt ; then
467 $MAKE adAll >> make.log 2>&1
468 else
469 if test "x$JOBS" = x ; then
470 $MAKE >> make.log 2>&1
471 else
472 $MAKE -j $JOBS >> make.log 2>&1
473 fi
474 fi
475 RETVAL=$?
476 if test "x$RETVAL" != x0 ; then
477 tail make.log
478 echo failed 1>&2
479 cp make.log $CDIR"/make.log"
480 rm -f $EXECUTABLE
481 return 1
482 else
483 echo successful 1>&2
484 fi
485 fi
486 fi
487 )
488 }
489
490 symlink_mpifiles()
491 {
492 # Put special links so that MPI specific files are used
493 # This MUST be invoked between makeclean and makelinks because
494 # the Makefile will link to non-mpi files by default
495
496 dir=$1
497 code_dir=$2
498 BUILD_DIR=$dir/$3
499 CODE_DIR=$dir/$code_dir
500
501 # These are files that should replace their counter-part when using -mpi
502 MPI_FILES=`(cd $CODE_DIR; find . -name "*_mpi" -print)`
503
504 # Is this an MPI run?
505 if test "x$MPI" = xt ; then
506 # YES: We symbolically link these files to the build
507 # dir so long as there is no real file in place
508 for ii in $MPI_FILES ; do
509 i=`echo $ii | sed 's:^\./::'`
510 name=`echo $i | sed 's:_mpi::' `
511 cmp $CODE_DIR/$i $BUILD_DIR/$name > /dev/null 2>&1
512 RETVAL=$?
513 if test "x$RETVAL" != x0 ; then
514 if ! test -f $BUILD_DIR/$i ; then
515 #echo Linking $name to $i
516 (cd $BUILD_DIR; ln -sf ../$code_dir/$i $name)
517 fi
518 fi
519 done
520 else
521 # NO: We undo any _mpi symbolically linked files
522 for ii in $MPI_FILES ; do
523 i=`echo $ii | sed 's:^\./::'`
524 name=`echo $i | sed 's:_mpi::' `
525 if test -L $BUILD_DIR/$name ; then
526 cmp $BUILD_DIR/$name "../$code_dir/$name"_mpi > /dev/null 2>&1
527 RETVAL=$?
528 if test "x$RETVAL" = x0 ; then
529 #echo Un-linking $name from $linktarg
530 rm -f $BUILD_DIR/$name
531 fi
532 fi
533 done
534 fi
535
536 }
537
538 linkdata()
539 {
540 # linkdata run_dir input_dir_1 input_dir_2 ...
541 #
542 # symbolically link data files to run directory
543 if test -d $1 ; then
544 (
545 cd $1 ; shift
546 inpMPI=`(cd ../$1 ; find . -name "*.mpi" -print | sed 's:^\./::')`
547 for xx in $inpMPI ; do
548 if test -r "../"$1"/"$xx ; then
549 # found 1 _mpi sfx file in 1rst input dir and it is readable
550 yy=`echo $xx | sed 's:\.mpi$::'`
551 if test "x$MPI" = "xt" ; then
552 # mpi test: remove symbolic link & link _mpi sfx file
553 if test -h $yy ; then rm -f $yy ; fi
554 if test ! -r $yy ; then
555 ln -sf "../"$1"/"$xx $yy ;
556 printf "$xx " 1>&2
557 fi
558 else
559 # not mpi test: remove symbolic link
560 if test -h $yy ; then rm -f $yy ; fi
561 fi
562 fi
563 done
564 if test -r "../"$1"/eedata.mth" ; then
565 # found eedata.mth in 1rst input dir and it is readable
566 if test "x$MULTI_THREAD" = "xt" ; then
567 # multi-threaded test: remove symbolic link & link eedata.mth
568 if test -h eedata ; then rm -f eedata ; fi
569 if test ! -r eedata ; then
570 ln -sf "../"$1"/eedata.mth" eedata ;
571 printf 'eedata.mth ' 1>&2
572 fi
573 else
574 # not multi-threaded test: remove eedata symbolic link
575 if test -h eedata ; then rm -f eedata ; fi
576 fi
577 fi
578 prevDir='NONE'
579 for ldir in $* ; do
580 if test -d "../"$ldir -a $ldir != $prevDir ; then
581 printf 'ldir='${ldir} 1>&2
582 files=`( cd "../"$ldir ; ls -1 | grep -v CVS )`
583 for i in $files ; do
584 if test ! -d "../"$ldir/$i ; then
585 if test ! -r $i ; then
586 printf ' '$i 1>&2
587 ln -sf "../"$ldir"/"$i $i
588 fi
589 fi
590 done
591 if test -x "../"$ldir"/"prepare_run ; then
592 "../"$ldir"/"prepare_run
593 fi
594 printf ' ; ' 1>&2
595 fi
596 prevDir=$ldir
597 done
598 )
599 fi
600 }
601
602 runmodel()
603 {
604 # runmodel directory
605 #
606 # runs "$COMMAND in "directory"
607 # (where "$COMMAND" is relative to "directory")
608 (
609 cd $1
610 printf 'runmodel in %s ...' $1 1>&2
611 # make output.txt
612 echo
613 if test -L $EXECUTABLE ; then
614 if test -x "../"$builddir"/"$EXECUTABLE ; then
615 diff -q $EXECUTABLE "../"$builddir"/"$EXECUTABLE > /dev/null 2>&1
616 outD=$? ; if test $outD != 0 ; then rm -f $EXECUTABLE ; fi
617 else rm -f $EXECUTABLE
618 fi
619 fi
620 if test ! -x $EXECUTABLE -a -x "../"$builddir"/"$EXECUTABLE ; then
621 echo " link" $EXECUTABLE "from dir ../"$builddir > run.log_tmp
622 ln -sf "../"$builddir"/"$EXECUTABLE .
623 fi
624 if test ! -x $EXECUTABLE ; then
625 rm -f $RUNLOG ; touch $RUNLOG
626 if test -f run.log_tmp ; then cat run.log_tmp >> $RUNLOG ; fi
627 echo " no executable:" $EXECUTABLE >> $RUNLOG
628 RETVAL=8
629 ENDVAL=-1
630 else
631 if test ! -f $OUTPUTFILE -o $OUTPUTFILE -ot $EXECUTABLE ; then
632 # output do not exist or is older than executable:
633 rm -f $RUNLOG ; touch $RUNLOG
634 if test -f run.log_tmp ; then cat run.log_tmp >> $RUNLOG ; fi
635 ( eval $COMMAND ) >> $RUNLOG 2>&1
636 RETVAL=$?
637 else
638 RETVAL=0
639 if test -f $RUNLOG ; then
640 if test -f run.log_tmp ; then cat run.log_tmp >> $RUNLOG ; fi
641 echo "---------->> $OUTPUTFILE is up to date " >> $RUNLOG 2>&1
642 else
643 touch $RUNLOG
644 if test -f run.log_tmp ; then cat run.log_tmp >> $RUNLOG ; fi
645 echo "---------->> $OUTPUTFILE is up to date " >> $RUNLOG 2>&1
646 echo " no previous $RUNLOG: assume NORMAL END" >> $RUNLOG 2>&1
647 fi
648 fi
649 ENDVAL=`cat $RUNLOG | grep -v 'ABNORMAL END' | grep -c 'NORMAL END'`
650 fi
651 rm -f run.log_tmp
652 if [ $RETVAL -eq 0 -a $ENDVAL -gt 0 ] ; then
653 tail $RUNLOG
654 echo successful 1>&2
655 # === Reduce the size of the testing emails!
656 #cp $OUTPUTFILE $CDIR"/"$OUTPUTFILE
657 if test -s STDERR.0000 ; then cp STDERR.0000 $CDIR"/STDERR.0000" ; fi
658 return 0
659 elif [ $RETVAL -ne 0 -a $ENDVAL -gt 0 ] ; then
660 #-- for some weird cases (run is finihed but with error code)
661 tail $RUNLOG
662 echo finished with error '(run:' $RETVAL ' end:' $ENDVAL ')' 1>&2
663 return 0
664 else
665 tail $RUNLOG
666 echo failed '(run:' $RETVAL ' end:' $ENDVAL ')' 1>&2
667 cp $RUNLOG $CDIR"/"$RUNLOG
668 if test -s STDERR.0000 ; then cp STDERR.0000 $CDIR"/STDERR.0000" ; fi
669 return 1
670 fi
671 )
672 }
673
674 createcodelet()
675 {
676 # create codelet for comparing model output
677
678 printf "creating the comparison code (using CC=$CC)... "
679 cat > tr_cmpnum.c <<EOF
680 #include <stdio.h>
681 #include <math.h>
682 int main( int argc, char** argv ) {
683 int linnum,cmplin,best,lncnt;
684 double a,b,abave,relerr;
685 best = -22;
686 lncnt = 0;
687 while( 1 & ( (lncnt+=1) < 999 ) ) {
688 scanf("%d", &linnum);
689 if (linnum == -1) break;
690 scanf("%lf", &a); scanf("%lf", &b);
691 abave = 0.5*(fabs(a)+fabs(b));
692 if ( abave == abave ) {
693 if (abave > 0.0) {
694 relerr=fabs(a-b)/abave;
695 if (relerr > 0.0) { cmplin = (int)rint(log10(relerr)); }
696 else { cmplin = -16 ; }
697 best = (best > cmplin) ? best : cmplin; }
698 else { cmplin = -22 ; }
699 /* printf("%d ; %lf ; %lf\n",cmplin,a,b); */
700 }
701 else {
702 /* printf("%lf ; %lf ; %lf\n",abave,a,b); */
703 break; }
704 }
705 if (lncnt == 999) best=-29;
706 if (linnum != -1) best=-99;
707 printf("%d\n", -best);
708 return 0;
709 }
710 EOF
711 $CC -o tr_cmpnum tr_cmpnum.c -lm
712
713 if [ -x ./tr_cmpnum ]; then
714 echo "OK"
715 return 0
716 else
717 echo
718 echo "ERROR: failed to compile comparison code -- please specify"
719 echo " a C compiler using the CC environment variable."
720 exit 1
721 fi
722 }
723
724 formatresults()
725 {
726 # formatresults expt genmake depend make run results*
727
728 nm=$1
729 printf '%s %s %s %s' $2 $3 $4 $5
730 shift; shift; shift; shift; shift;
731 listPrt=$@
732 listRes=`echo $listPrt | sed 's/>//' | sed 's/<//'`
733 xx=`echo $listPrt | sed 's/.*>//' | sed 's/<.*//' | awk '{print $1}'`
734 printf '%3s' $listPrt
735 # line below does not work on hp-ux_ia64 : do those substitutions later on
736 # printf '%3s' $listPrt | sed 's/ 99/ --/g' | sed 's/ > />/' | sed 's/ < /</'
737
738 if [ $xx = '..' ]; then
739 printf ' N/O '
740 elif [ $xx = '--' ]; then
741 printf ' N/O '
742 elif [ $xx = 99 ]; then
743 printf ' N/O '
744 else
745 if [ $xx -ge $MATCH_CRIT ]; then
746 printf ' pass'
747 else
748 printf ' FAIL'
749 fi
750 fi
751 printf ' %s' $nm
752 printf '\n'
753
754 }
755
756 scandirs()
757 {
758 if [ $# -eq 1 ]; then
759 for arg in * ; do
760 test -f $arg/$1 && echo $arg
761 done
762 else
763 echo $*
764 fi
765 }
766
767
768 check_eedata()
769 {
770 # check_eedata size.h eedata
771 if [ $# -eq 2 ] ; then
772 if test -f $1 -a -f $2 ; then
773 sx=`grep "^ & *nSx *=" $1 | sed "s/^ & *nSx *=//" | sed 's/, *$//'`
774 nx=`grep "^ *nTx *=" $2 | tail -1 | sed 's/^ *nTx *= *//' | sed "s/, *$//"`
775 if test "x$nx" = x ; then
776 rx=10
777 else
778 rx=`expr $sx % $nx`
779 fi
780 sy=`grep "^ & *nSy *=" $1 | sed "s/^ & *nSy *=//" | sed 's/, *$//'`
781 ny=`grep "^ *nTy *=" $2 | tail -1 | sed 's/^ *nTy *= *//' | sed "s/, *$//"`
782 if test "x$ny" = x ; then
783 ry=20
784 else
785 ry=`expr $sy % $ny`
786 fi
787 echo `expr $rx + $ry`
788 else
789 echo '-1'
790 fi
791 else
792 echo '-2'
793 fi
794
795 }
796
797 ###############################################################################
798
799
800 # Default properties
801 debug=0
802 verbose=1
803 clean=0
804
805 IEEE=true
806 if test "x$MITGCM_IEEE" != x ; then
807 IEEE=$MITGCM_IEEE
808 fi
809 GSL=f
810
811 CLEANUP=f
812 NORUN=f
813 QUICK=f
814 NOMAKE=f
815 NOGENMAKE=f
816 NOCLEAN=f
817 NODEPEND=f
818 POSTCLEAN=f
819
820 BASH=
821 OPTFILE=NONE
822 ADDRESSES=
823 TESTDIRS=
824 SKIPDIRS=
825 MPACKDIR="../tools/mpack-1.6"
826 HAVE_MPACK=
827 MPACK=
828 COMMAND=
829 if test "x$MAKE" = x ; then
830 MAKE=make
831 fi
832 if test "x$CC" = x ; then
833 CC=cc
834 fi
835 JOBS=
836 MPI=f
837 MULTI_THREAD=f
838 OUTDIR=
839 DELDIR=
840 USE_R4=
841
842 ADM=
843 OADM=
844
845 # list of pTracers to check for monitor output
846 PTRACERS_NUM="1 2 3 4 5"
847
848 MATCH_CRIT=13
849
850 printf "parsing options... "
851
852 ac_prev=
853 for ac_option ; do
854
855 # If the previous option needs an argument, assign it.
856 if test -n "$ac_prev"; then
857 eval "$ac_prev=\$ac_option"
858 ac_prev=
859 continue
860 fi
861
862 ac_optarg=`expr "x$ac_option" : 'x[^=]*=\(.*\)'`
863
864 case $ac_option in
865
866 -help | --help | -h | --h)
867 usage ;;
868
869 -optfile | --optfile | -of | --of)
870 ac_prev=OPTFILE ;;
871 -optfile=* | --optfile=* | -of=* | --of=*)
872 OPTFILE=$ac_optarg ;;
873
874 -addr | --addr | -a | --a)
875 ac_prev=ADDRESSES ;;
876 -addr=* | --addr=* | -a=* | --a=*)
877 ADDRESSES=$ac_optarg ;;
878 -mpackdir | --mpackdir | -mpd | --mpd)
879 ac_prev=MPACKDIR ;;
880 -mpackdir=* | --mpackdir=* | -mpd=* | --mpd=*)
881 MPACKDIR=$ac_optarg ;;
882
883 -tdir | --tdir | -t | --t)
884 ac_prev=TESTDIRS ;;
885 -tdir=* | --tdir=* | -t=* | --t=*)
886 TESTDIRS=$ac_optarg ;;
887
888 -skipdir | --skipdir | -skd | --skd)
889 ac_prev=SKIPDIRS ;;
890 -skipdir=* | --skipdir=* | -skd=* | --skd=*)
891 SKIPDIRS=$ac_optarg ;;
892
893 -bash | --bash | -b | --b)
894 ac_prev=BASH ;;
895 -bash=* | --bash=* | -b=* | --b=*)
896 BASH=$ac_optarg ;;
897
898 -command | --command | -c | --c)
899 ac_prev=COMMAND ;;
900 -command=* | --command=* | -c=* | --c=*)
901 COMMAND=$ac_optarg ;;
902
903 -make | --make | -m | --m)
904 ac_prev=MAKE ;;
905 -make=* | --make=* | -m=* | --m=*)
906 MAKE=$ac_optarg ;;
907
908 -odir | --odir)
909 ac_prev=OUTDIR ;;
910 -odir=* | --odir=*)
911 OUTDIR=$ac_optarg ;;
912
913 -ptracers | --ptracers | -ptr | --ptr)
914 ac_prev=PTRACERS_NUM ;;
915 -ptracers=* | --ptracers=* | -ptr=* | --ptr=*)
916 PTRACERS_NUM=$ac_optarg ;;
917
918 -match | --match ) ac_prev=MATCH_CRIT ;;
919 -match=* | --match=* ) MATCH_CRIT=$ac_optarg ;;
920
921 -j | --j) ac_prev=JOBS ;;
922 -j=* | --j=*) JOBS=$ac_optarg ;;
923
924 -clean | --clean)
925 CLEANUP=t ; DELDIR=t ;;
926
927 -norun | --norun | -nr | --nr)
928 NORUN=t ;;
929 -runonly | --runonly | -ro | --ro)
930 QUICK=t ; NOMAKE=t ;;
931 -quick | --quick | -q | --q)
932 QUICK=t ;;
933 -nogenmake | --nogenmake | -ng | --ng)
934 NOGENMAKE=t ;;
935 -noclean | --noclean | -nc | --nc)
936 NOCLEAN=t ;;
937 -nodepend | --nodepend | -nd | --nd)
938 NODEPEND=t ;;
939
940 -postclean | --postclean | -pc | --pc)
941 POSTCLEAN=t ;;
942
943 -mpi) MPI=t ;;
944
945 -mth) MULTI_THREAD=t ;;
946
947 -adm | -ad) ADM=t ;;
948
949 -oad) OADM=t; NODEPEND=t ;;
950
951 -ieee) IEEE=true ;;
952 -noieee) IEEE= ;;
953 -gsl) GSL=t ;;
954
955 -verbose) verbose=2 ;;
956 -debug) debug=1 ;;
957 -quiet) verbose=0 ;;
958
959 -deldir | -dd) DELDIR=t ;;
960
961 -use_r4|-ur4) USE_R4=t ;;
962
963 -ts) TS=t;;
964 -papis) PAPIS=t;;
965 -pcls) PCL=t;;
966
967 -*)
968 echo "Error: unrecognized option: "$ac_option
969 usage
970 ;;
971
972 *)
973 echo "Error: unrecognized argument: "$ac_option
974 usage
975 ;;
976
977 esac
978
979 done
980
981 if test "x$QUICK" = xt ; then
982 NOGENMAKE=t
983 NOCLEAN=t
984 NODEPEND=t
985 fi
986
987 #- setting for forward or ADM testing
988 if test "x$ADM" = xt ; then
989 code_dir=code_ad
990 inputdir=input_ad
991 ref_outp="output_adm.txt"
992 EXECUTABLE="mitgcmuv_ad"
993 elif test "x$OADM" = xt ; then
994 code_dir=code_oad
995 inputdir=input_oad
996 ref_outp="output_oadm.txt"
997 EXECUTABLE="mitgcmuv_ad"
998 else
999 code_dir=code
1000 inputdir=input
1001 ref_outp="output.txt"
1002 EXECUTABLE="mitgcmuv"
1003 fi
1004
1005 if test "x$TESTDIRS" = x ; then
1006 LIST=`scandirs results/$ref_outp`
1007 else
1008 #- expand group of experiments:
1009 LIST=" "
1010 for xx in $TESTDIRS
1011 do
1012 case $xx in
1013 'basic') LIST=${LIST}" aim.5l_cs hs94.128x64x5 ideal_2D_oce"
1014 LIST=${LIST}" lab_sea tutorial_baroclinic_gyre"
1015 LIST=${LIST}" tutorial_global_oce_latlon tutorial_plume_on_slope"
1016 ;;
1017 'tutorials')
1018 LIST=${LIST}" "`ls | grep 'tutorial_'` ;;
1019 *) LIST=${LIST}" "$xx ;;
1020 esac
1021 done
1022 fi
1023 #echo 'LIST='${LIST}'<'
1024 #- skip dirs, remove duplicate and non-directory:
1025 TESTDIRS=" "
1026 count=0
1027 for xx in $LIST
1028 do
1029 yy=`echo $SKIPDIRS | grep -c $xx`
1030 if test $yy = 0 ; then
1031 if test -d $xx ; then
1032 yy=`echo $TESTDIRS | grep -c $xx`
1033 if test $yy = 0 ; then TESTDIRS=${TESTDIRS}" "$xx ; fi
1034 else count=1 ;
1035 echo ""; echo -n " -- skip \"$xx\" (not a directory !)"
1036 fi
1037 else
1038 if test $count = 1 ; then echo -n ", \"$xx\""
1039 else count=1 ; echo "" ; echo -n " skip: \"$xx\""
1040 fi
1041 fi
1042 done
1043 if test $count = 1 ; then echo "" ; echo -n " ... " ; fi
1044 #echo 'TESTDIRS='${TESTDIRS}'<'
1045
1046 if test "x$OPTFILE" = xNONE -a "x$MITGCM_OF" != x ; then
1047 OPTFILE=$MITGCM_OF
1048 fi
1049
1050 RUNLOG="run.log"
1051 OUTPUTFILE=$ref_outp
1052 if test "x$COMMAND" = x ; then
1053 COMMAND="./$EXECUTABLE > $OUTPUTFILE"
1054 fi
1055 if test "x$MPI" = xt ; then
1056 OUTPUTFILE="STDOUT.0000"
1057 fi
1058
1059 echo "OK (COMMAND= $COMMAND )"
1060
1061 # set the Default List of output variables to be checked:
1062 # (use default or load experiment-specific list from file "tr_checklist")
1063 # content : 1rst = main variable used to decide if it pass or FAIL
1064 # others = number of matching digits to be printed in summary.txt
1065 if test "x$ADM" = x -a "x$OADM" = x; then
1066 DEF_CHECK_LIST='PS PS T+ S+ U+ V+ pt1+ pt2+ pt3+ pt4+ pt5+'
1067 EMPTY_RESULTS='.. .. .. .. .. .. .. .. .. .. .. .. .. .. .. .. ..'
1068 LEN_CHECK_LIST=`echo $DEF_CHECK_LIST | sed 's/ [a-zA-Z0-9]*+/&mn &mx &av &sd/g' | awk '{print NF-1}'`
1069 ii=`echo $EMPTY_RESULTS | awk '{print NF}'`
1070 EMPTY_RESULTS=$EMPTY_RESULTS`expr $LEN_CHECK_LIST - $ii | awk 'BEGIN{FS=":"}{for(i=1;i<=$1;i++){printf " ."}}'`
1071 else
1072 DEF_CHECK_LIST='Grad Cost Grad'
1073 EMPTY_RESULTS='.. ..'
1074 LEN_CHECK_LIST=`echo $DEF_CHECK_LIST | sed 's/ [a-zA-Z0-9]*+/&mn &mx &av &sd/g' | awk '{print NF-1}'`
1075 fi
1076
1077 # create the FORTRAN comparison code
1078 if test -x tr_cmpnum ; then
1079 echo "skipping comparison code build"
1080 else
1081 createcodelet
1082 fi
1083
1084 # build the mpack utility (if ADDRESSES = NONE, do it to test the build)
1085 if test "x$ADDRESSES" = x ; then
1086 echo "skipping mpack build"
1087 else
1088 build_mpack
1089 fi
1090
1091 # Create a uniquely named directory to store results
1092 CMDLINE=$0
1093 for xx in "$@" ; do nw=`echo $xx | wc -w`
1094 if test $nw = '1' ; then CMDLINE="$CMDLINE $xx"
1095 else CMDLINE="$CMDLINE '$xx'" ; fi
1096 done
1097 #for xx in "$@" ; do CMDLINE="$CMDLINE '$xx'" ; done
1098 MACH=`hostname`
1099 UNAMEA=`uname -a`
1100 DATE=`date +%Y%m%d`
1101 BASE="tr_"$MACH"_"$DATE"_"
1102 if test "x$OUTDIR" != x ; then
1103 BASE="tr_"$OUTDIR"_"$DATE"_"
1104 else
1105 short_name=`hostname | sed 's/\..*$//'`
1106 BASE="tr_"$short_name"_"$DATE"_"
1107 fi
1108 DNUM=0
1109 DRESULTS="$BASE$DNUM"
1110 while test -e $DRESULTS ; do
1111 DNUM=$(( $DNUM + 1 ))
1112 DRESULTS="$BASE$DNUM"
1113 done
1114 mkdir $DRESULTS
1115 RETVAL=$?
1116 if test "x$RETVAL" != x0 ; then
1117 echo "ERROR: Can't create results directory \"./$DRESULTS\""
1118 exit 1
1119 fi
1120 SUMMARY="$DRESULTS/summary.txt"
1121 start_date=`date`
1122 echo $start_date > $SUMMARY
1123 echo 'run:' $CMDLINE >> $SUMMARY
1124 echo 'on :' $UNAMEA >> $SUMMARY
1125
1126 of_path=
1127 if test "x$OPTFILE" != xNONE ; then
1128 if test -r $OPTFILE ; then
1129 # get the path
1130 path=${OPTFILE%/*}
1131 if test "x$path" = x ; then
1132 of_path=`pwd`
1133 else
1134 of_path=`( cd $path > /dev/null 2>&1 ; pwd )`
1135 fi
1136 file=${OPTFILE##*/}
1137 OPTFILE=$of_path/$file
1138 cp $OPTFILE $DRESULTS
1139 echo >> $SUMMARY
1140 echo " OPTFILE=$OPTFILE" >> $SUMMARY
1141 else
1142 echo | tee $SUMMARY
1143 echo "ERROR: can't read OPTFILE=\"$OPTFILE\"" | tee $SUMMARY
1144 exit 1
1145 fi
1146 else
1147 echo >> $SUMMARY
1148 echo "No \"OPTFILE\" was explicitly specified by testreport," >> $SUMMARY
1149 echo " so the genmake default will be used." >> $SUMMARY
1150 fi
1151 echo
1152 echo >> $SUMMARY
1153 if test "x$ADM" = x -a "x$OADM" = x; then
1154 if [ $MATCH_CRIT -lt 10 ] ;
1155 then line_0="default "$MATCH_CRIT ;
1156 else line_0="default "$MATCH_CRIT ; fi
1157 line_0="$line_0 ----T----- ----S----- ----U----- ----V-----"
1158 # line_0=" ----T----- ----S----- ----U----- ----V-----"
1159 line_1="G D M c m s m s m s m s"
1160 line_2="E p a R g m m e . m m e . m m e . m m e ."
1161 line_3="N n k u 2 i a a d i a a d i a a d i a a d"
1162 line_4="2 d e n d n x n . n x n . n x n . n x n ."
1163 for ii in $PTRACERS_NUM ; do
1164 line_0="$line_0 --PTR 0"$ii"--"
1165 line_1="$line_1 m s"
1166 line_2="$line_2 m m e ."
1167 line_3="$line_3 i a a d"
1168 line_4="$line_4 n x n ."
1169 done
1170 echo "$line_0" | tee -a $SUMMARY
1171 echo "$line_1" | tee -a $SUMMARY
1172 echo "$line_2" | tee -a $SUMMARY
1173 echo "$line_3" | tee -a $SUMMARY
1174 echo "$line_4" | tee -a $SUMMARY
1175 echo " " | tee -a $SUMMARY
1176 else
1177 echo "ADJOINT=true" >> $SUMMARY
1178 echo >> $SUMMARY
1179 if [ $MATCH_CRIT -lt 10 ] ;
1180 then line_0="default "$MATCH_CRIT ;
1181 else line_0="default "$MATCH_CRIT ; fi
1182 echo "$line_0" | tee -a $SUMMARY
1183 cat << EOF | tee -a $SUMMARY
1184 G D M C G
1185 E p a R o r
1186 N n k u s a
1187 2 d e n t d
1188
1189 EOF
1190 fi
1191
1192 # ...and each test directory...
1193 for dir in $TESTDIRS ; do
1194
1195 # set builddir & rundir:
1196 builddir="build"
1197 if test ! -d $dir/$builddir ; then mkdir $dir/$builddir ; fi
1198 rundir="run"
1199 if test ! -d $dir/$rundir ; then
1200 rundir=$builddir
1201 fi
1202 CODE_DIR=$dir/$code_dir
1203 BUILD_DIR=$dir/$builddir
1204
1205 # Cleanup only!
1206 if test "x$CLEANUP" = xt ; then
1207 echo -n ' --- dir:' $BUILD_DIR ': '
1208 makeclean $BUILD_DIR
1209 rm -f $BUILD_DIR/$EXECUTABLE
1210 if test -d $dir/$rundir/CVS ; then
1211 echo -n ' --- dir:' $dir/$rundir ': '
1212 run_clean $dir/$rundir
1213 fi
1214 trdir=`( cd $dir ; find . -type d -name "tr_run.*" -print | sed 's/^.\///')`
1215 ttd=`echo $trdir | wc -w`
1216 if test $ttd != 0 ; then
1217 echo ' --- rm dir:' $trdir
1218 ( cd $dir ; rm -rf $trdir )
1219 fi
1220 continue
1221 fi
1222
1223 # Verify that the testdir exists and contains previous
1224 # results in the correct location--or skip this directory!
1225 fout=$dir"/results/"$ref_outp
1226 if test ! -r $fout ; then
1227 echo "can't read \"$fout\" -- skipping $dir"
1228 continue
1229 fi
1230
1231 # Check for specific files for particular type of run
1232
1233 if test ! -r $CODE_DIR"/SIZE.h_mpi" -a "x$MPI" = "xt" ; then
1234 echo "can't find \"$CODE_DIR/SIZE.h_mpi\" -- skipping $dir"
1235 continue
1236 fi
1237 if test ! -r $dir"/input/eedata.mth" -a "x$MULTI_THREAD" = "xt" ; then
1238 echo "can't find \"$dir/input/eedata.mth\" -- skipping $dir"
1239 continue
1240 fi
1241 if test "x$MPI" = "xt" -a "x$MULTI_THREAD" = "xt" ; then
1242 retv=`check_eedata $CODE_DIR"/SIZE.h_mpi" $dir"/input/eedata.mth"`
1243 if test $retv != 0 ; then
1244 echo "input/eedata.mth tiling misfit -- skipping $dir"
1245 continue
1246 fi
1247 fi
1248
1249 # Check whether there are "extra runs" for this testdir
1250 extra_runs=
1251 if test "x$NORUN" = xf ; then
1252 ex_run_dirs=`( cd $dir ; echo $inputdir.* )`
1253 fi
1254 #echo "ex_run_dirs='$ex_run_dirs'"
1255 for exd in $ex_run_dirs ; do
1256 name=`echo $exd | sed -e "s/$inputdir\.//"`
1257 refExOut=`echo $ref_outp | sed "s/\./.${name}./"`
1258 outf="$dir/results/$refExOut"
1259 if test -f $outf -a -r $outf ; then
1260 if test "x$MULTI_THREAD" = "xt" ; then
1261 if test -r $dir"/"$exd"/eedata.mth" ; then
1262 if test "x$MPI" = "xt" ; then
1263 retv=`check_eedata $CODE_DIR"/SIZE.h_mpi" $dir"/"$exd"/eedata.mth"`
1264 if test $retv = 0 ; then
1265 extra_runs="$extra_runs $name"
1266 else
1267 echo $exd"/eedata.mth tiling misfit -- skipping $dir"
1268 fi
1269 else
1270 extra_runs="$extra_runs $name"
1271 fi
1272 #else echo $dir"/"$exd"/eedata.mth: not found"
1273 fi
1274 else
1275 extra_runs="$extra_runs $name"
1276 fi
1277 fi
1278 done
1279
1280 echo "-------------------------------------------------------------------------------"
1281 echo
1282 if test "x$extra_runs" = "x" ; then
1283 echo "Experiment: $dir"
1284 else
1285 echo "Experiment: $dir ; extra_runs=$extra_runs"
1286 fi
1287 echo
1288 unset genmake makedepend make run
1289 results=$EMPTY_RESULTS
1290
1291 # Create an output dir for each OPTFILE/tdir combination
1292 rel_CDIR=$DRESULTS"/"$dir
1293 mkdir $rel_CDIR
1294 CDIR=`pwd`"/$rel_CDIR"
1295
1296 if test "x$NORUN" = xt ; then
1297 run=N
1298 genmakemodel $dir/$builddir && genmake=Y \
1299 && makeclean $dir/$builddir \
1300 && run_clean $dir/$rundir \
1301 && symlink_mpifiles $dir $code_dir $builddir \
1302 && makedependmodel $dir/$builddir && makedepend=Y \
1303 && makemodel $dir/$builddir && make=Y
1304 else
1305 genmakemodel $dir/$builddir && genmake=Y \
1306 && makeclean $dir/$builddir \
1307 && run_clean $dir/$rundir \
1308 && symlink_mpifiles $dir $code_dir $builddir \
1309 && makedependmodel $dir/$builddir && makedepend=Y \
1310 && makemodel $dir/$builddir && make=Y \
1311 && linkdata $dir/$rundir $inputdir input \
1312 && runmodel $dir/$rundir && run=Y \
1313 && results=`testoutput_run $dir $rundir $ref_outp`
1314 fi
1315
1316 #echo "results='$results'"
1317 echo
1318 fres=`formatresults $dir ${genmake:-N} ${makedepend:-N} ${make:-N} ${run:-N} $results`
1319 echo
1320 echo "$fres" | sed 's/ 99/ --/g' | sed 's/ > />/' | sed 's/ < /</' >> $SUMMARY
1321 touch $CDIR"/summary.txt"
1322 echo "fresults='$fres'" | sed 's/ 99/ --/g' >> $CDIR"/summary.txt"
1323 echo "MACH='$MACH'" >> $CDIR"/summary.txt"
1324 echo "UNAMEA='$UNAMEA'" >> $CDIR"/summary.txt"
1325 echo "DATE='$DATE'" >> $CDIR"/summary.txt"
1326 echo "tdir='$dir'" >> $CDIR"/summary.txt"
1327 if test "x$ADM" = xt ; then
1328 head -1 $dir/$builddir/taf_ad.log >> $CDIR"/summary.txt"
1329 grep -A3 'Seconds in section "ALL' $dir/$rundir/$OUTPUTFILE \
1330 >> $CDIR"/summary.txt"
1331 fi
1332
1333 for ex in $extra_runs ; do
1334 unset run
1335 results=$EMPTY_RESULTS
1336 # reference output file
1337 refExOut=`echo $ref_outp | sed "s/\./.${ex}./g"`
1338 # Create an output dir for each OPTFILE/tdir.ex combination
1339 rel_CDIR=$DRESULTS"/"$dir"."$ex
1340 mkdir $rel_CDIR
1341 CDIR=`pwd`"/$rel_CDIR"
1342 test ! -e "$dir/tr_run.$ex" && mkdir "$dir/tr_run.$ex"
1343 run_clean $dir/tr_run.$ex
1344 linkdata $dir/tr_run.$ex $inputdir.$ex $inputdir input
1345 runmodel $dir/tr_run.$ex && run=Y \
1346 && results=`testoutput_run $dir tr_run.$ex $refExOut`
1347 fres=`formatresults $dir ${genmake:-N} ${makedepend:-N} ${make:-N} ${run:-N} $results`
1348 fres="$fres.$ex"
1349 echo
1350 echo "$fres" | sed 's/ 99/ --/g' | sed 's/ > />/' | sed 's/ < /</' >> $SUMMARY
1351 touch $CDIR"/summary.txt"
1352 echo "fresults='$fres'" | sed 's/ 99/ --/g' >> $CDIR"/summary.txt"
1353 echo "MACH='$MACH'" >> $CDIR"/summary.txt"
1354 echo "UNAMEA='$UNAMEA'" >> $CDIR"/summary.txt"
1355 echo "DATE='$DATE'" >> $CDIR"/summary.txt"
1356 echo "tdir='$dir.$ex'" >> $CDIR"/summary.txt"
1357 if test "x$ADM" = xt ; then
1358 head -1 $dir/$builddir/taf_ad.log >> $CDIR"/summary.txt"
1359 grep -A3 'Seconds in section "ALL' $dir/tr_run.$ex/$OUTPUTFILE \
1360 >> $CDIR"/summary.txt"
1361 fi
1362 if test "x$POSTCLEAN" = xt ; then
1363 run_clean $dir/tr_run.$ex
1364 fi
1365 done
1366
1367 #postclean $dir/$builddir
1368 if test "x$POSTCLEAN" = xt ; then
1369 makeclean $dir/$builddir \
1370 && run_clean $dir/$rundir
1371 fi
1372
1373 echo "-------------------------------------------------------------------------------"
1374
1375 done
1376
1377 printf "Start time: " >> $SUMMARY
1378 echo "$start_date" >> $SUMMARY
1379 printf "End time: " >> $SUMMARY
1380 date >> $SUMMARY
1381
1382 # If addresses were supplied and mpack built successfully, then try
1383 # to send email using mpack.
1384 if test "x$ADDRESSES" = xNONE -o "x$ADDRESSES" = x ; then
1385 echo "No results email was sent."
1386 else
1387 if test "x$HAVE_MPACK" = xt ; then
1388 tar -cf $DRESULTS".tar" $DRESULTS > /dev/null 2>&1 \
1389 && gzip $DRESULTS".tar" \
1390 && $MPACK -s MITgcm-test -m 3555000 $DRESULTS".tar.gz" $ADDRESSES
1391 RETVAL=$?
1392 if test "x$RETVAL" != x0 ; then
1393 echo
1394 echo "Warning: The tar, gzip, & mpack step failed. Please send email"
1395 echo " to <MITgcm-support@mitgcm.org> for help. You may copy the "
1396 echo " summary of results from the directory \"$DRESULTS\"."
1397 echo
1398 else
1399 echo
1400 echo "An email containing results was sent to the following addresses:"
1401 echo " \"$ADDRESSES\""
1402 echo
1403 test -f $DRESULTS".tar" && rm -f $DRESULTS".tar"
1404 test -f $DRESULTS".tar.gz" && rm -f $DRESULTS".tar.gz"
1405 fi
1406 fi
1407 fi
1408
1409 if test "x$QUICK" = xf -a "x$NORUN" = xf ; then
1410 rm -f tr_cmpnum.c tr_cmpnum
1411 fi
1412
1413 if test "x$CLEANUP" != xt ; then
1414 cat $SUMMARY | sed 's/ \. \. \. \. \. \. \. \. \. \. \. \. //'
1415 if test -e tr_out.txt ; then
1416 mv tr_out.txt tr_out.txt.old
1417 fi
1418 cat $SUMMARY | sed '/^[YN] [YN] [YN] [YN]/ s/ \. //g' > tr_out.txt
1419 fi
1420
1421 if test "x$DELDIR" = xt ; then
1422 rm -rf $DRESULTS
1423 fi

  ViewVC Help
Powered by ViewVC 1.1.22